#ifndef CLIB_CMANAGER_PROTOS_H
#define CLIB_CMANAGER_PROTOS_H

/*
**  $VER: CManager_protos.h 25.3 (18.1.2004)
**  Includes Release 25.3
**
**  C prototypes. For use with 32 bit integers only.
**
**  Written by Simone Tellini <wiz@vapor.com> and
**             Alfonso Ranieri <alforan@tin.it>.
**
**  Released under the terms of the
**  GNU Public Licence version 2
*/

#ifndef LIBRARIES_CMANAGER_H
#include <libraries/CManager.h>
#endif

/* Database */
struct CMData *CM_AllocCMData( void );
struct CMGroup  *CM_GetParent( struct CMGroup *, struct CMGroup * );
BOOL CM_LoadData( STRPTR, struct CMData *, STRPTR );
struct CMData *CM_LoadCurrentUserData( BOOL );
void CM_SaveData( STRPTR, struct CMData *, STRPTR );
void CM_FreeData( struct CMData * );
APTR CM_AllocEntry( ULONG );
void CM_FreeEntry( APTR );
APTR CM_GetEntry( APTR, ULONG );
BOOL CM_AddEntry( APTR );
void CM_FreeList( struct MinList * );
BOOL CM_LoadDataOld( STRPTR, struct CMDataOld *, STRPTR );
void CM_SaveDataOld( STRPTR, struct CMDataOld *, STRPTR );
void CM_FreeDataOld( struct CMDataOld * );

/* Application */
APTR CM_StartManager( STRPTR, STRPTR );
void CM_FreeHandle( APTR, BOOL );
APTR CM_StartCManagerA( struct TagItem *);
APTR CM_StartCManager( Tag , ... );

/* Bitmaps - Obsolete! CM_CreateBitMap return NULL, CM_DeleteBitMap() does nothing! */
struct BitMap *CM_CreateBitMap( ULONG, ULONG, ULONG, ULONG, struct BitMap * );
void CM_DeleteBitMap( struct BitMap * );

/* Variuos */
STRPTR CM_GetString( ULONG ID );
ULONG CM_GetOption(ULONG option);

#endif /* CLIB_CMANAGER_PROTOS_H */
