* SearchStar

	INCDIR	"STORMC:ASM-Include/"

	INCLUDE	LVOs/exec_lib.i
	INCLUDE	exec/memory.i
	INCLUDE LVOs/dos_lib.i
	INCLUDE dos/dos.i
	INCLUDE dos/dosextens.i
;	INCLUDE LVOs/workbench_lib.i
;	INCLUDE	workbench/workbench.i

_SYSBase	EQU	4
TRUE		EQU	-1
FALSE		EQU	0

filelen		EQU	256	;filename lenght, must be at least 103, maximum Amiga filename lenght

************membuf offsets (smalldata in a4)************
* Warning: if offset reverseCASE block changes, it's possible the program mallfunctions !! (GURU 80000003 too)
* Behind reverseCASE block are no offsets allowed, reverseCASE is a memory block ! (needs no more then 256b)
*
*-4	WBStartup Message
* 0	_DOSBase
* 4	outputhandle
* 8
* 12	ReadCommandLen
* 16	ReadCommandBuf
* 20	DIR base
* 24	SEARCH base
* 28	SAVEDIR base (0 if not present)
* 32	BUFFER value
* 36	REPLACE base (0 if not present)
* 40	EXACT	TRUE (-1) FALSE (0) flag wordsize
* 42	CASE	TRUE (-1) FALSE (0) flag wordsize
* 44	QUIET	TRUE (-1) FALSE (0) flag wordsize
* 46	THRU	TRUE (-1) FALSE (0) flag wordsize
* 48	pathbuf, buffer path and all subdirs longwordsize
* 52	DELAY value longwordsize
* 56	reserve one FileInfoBlock for save routine longwordsize
* 60	new SAVEDIR longwordsize
* 64	new SAVEDIR, pointer at end for appending (matched) filename easily longwordsize
* 68	ReadFileBuffer for save routine (temporary)
* 72	ReadFileLenght for save routine (temporary)
* 76	savelock for save routine (temporary)
* 80	filehandle for save routine (temporary)
* 84	SEARCH lenght for THRU EXACT and REPLACE EXACT routines wordsize
* 88	lenght REPLACE-SEARCH for REPLACE routines longwordsize
* 92	lenght REPLACE memoryblock (temporary)
* 96	buffer REPLACE memoryblock (temporary)
* 104	reverseCASE block buffer for the reversed case char. for the case insensitive routines

;Shell arguments: (contains Shell (CLI) arguments to read)

	move.l	a0,a2				;store a0 start address (file pathname) in a2
	move.l	d0,d3				;store d0 lenght in d3

*Workbench or CLI startup code:

	suba.l	a1,a1
	move.l  (_SYSBase).w,a6			;base Exec in a6
	jsr     _LVOFindTask(a6)		;find us
	move.l	d0,a3				;pointer in a3
membuf
	lea	membuf(pc),a4			;a4 is smalldata register, saves bytes !!

*open DOS library:

	lea	dosname(pc),a1			;"dos.library"
	moveq	#0,d0
;	move.l	(_SYSBase).w,a6
	jsr     _LVOOpenLibrary(a6)		;trashed d1 and a0 a1 !
	move.l	d0,(a4)				;store _DOSBase
	move.l	d0,_DOSBase			;TEST voor output32

	tst.l	pr_CLI(a3)
	bne	fromCLI				;if we were called from CLI: fromCLI

; we were called from the Workbench

	lea	pr_MsgPort(a3),a0
	jsr	_LVOWaitPort(a6)		;WaitPort(port)(a0) wait for a message
	lea	pr_MsgPort(a3),a0
	jsr	_LVOGetMsg(a6)			;GetMsg(port)(a0) then get it
	move.l	d0,-4(a4)			;save WBStartup Message for later reply
;	move.l	d0,a2				;and in a2 (only for tooltypes reading later)

fromWB	;do here Workbench code

;The follow commandline are only nessecary for Workbench code, it's useless now but move it
;in the Workbench code when this is present. It's speedsup the save routine a littlebit.
;It can't in the early beginning of the program, because it's saves a variable in 44(a4)
;which trashes the running program !
;move it further in the program code, please !

;	move.w	#-1,44(a4)			;set QUIET at yes (-1) ANDERS ; ervoor



fromCLI

	clr.l	-4(a4)				;make NULL WBStartup Message

*outputhandle:

	move.l	d0,a6				;_DOSBase in a6
	jsr	_LVOOutput(a6)			;Output()()
	move.l	d0,4(a4)			;store outputhandle
	move.l	d0,outputhandle			;TEST voor output32

;allocate memory to store commandline in

	move.l	d3,d0

	add.l	#2,d0				;lenght 2 higher for adding null-word
	move.l	d0,12(a4)			;ReadCommandLen
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l  (_SYSBase).w,a6			;base Exec in a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1)
	move.l	d0,16(a4)			;ReadCommandBuf
	beq	fini				;can't allocate memory -> fini, close program
	move.l	d0,a1
	move.l	d0,a3				;address new Shellcommandline in a3, used for later

*********Begin parsing Shell (CLI) arguments************************************

	move.b	#34,d1				;" char. in d1 (is faster and saves 4bytes)
	move.b	#10,d2				;"Return"  char. in d2 (is faster and saves again 4bytes)
	move.b	#32,d3				;"Space"  char. in d3 (is faster and saves another 4bytes)

FirstChar
	move.b	(a2)+,d0
	cmp.b	d1,d0				;is first " char. found ?
	beq	CheckDoubleQuote
	cmp.b	d2,d0				;is first "Return" found ?
	beq	UsageText			;found "Return" as first char. ->UsageText
	cmp.b	#"?",d0				;is first "?" found ?
	bne	NextSpace			;no, then find next space
;found "?" as first char. Look for "Return" or "Space" behind "?" then goto UsageText
	cmp.b	(a2),d2				;is "Return" behind "?" found ?
	beq	UsageText
	cmp.b	(a2),d3				;is "Space" behind "?" found ?
	bne	NextSpace			;no, then find next space
	bra	UsageText

CheckDoubleQuote
	move.b	(a2)+,d0
	cmp.b	d1,d0				;is double " char. found ? ('""')
	bne	QuoteReturn
	bra	WrongArguments			;no double "" allowed ->WrongArguments (avoid 2nd null-byte)
NextQuoteSpace
	move.b	(a2)+,d0
	cmp.b	d1,d0				;is next " char. found ?
	beq	BehindSpaceReturn
QuoteReturn
	cmp.b	d2,d0				;is "Return" found ?
	beq	WrongArguments			;"Return", end reached, no 2nd Quote found ->WrongArguments
	move.b	d0,(a1)+			;into buffer
	bra	NextQuoteSpace
BehindSpaceReturn
	clr.b	(a1)+				;set null-byte into buffer
	move.b	(a2)+,d0
	cmp.b	d3,d0				;is next "Space" found ? (more spaces posible)
	beq	MoreLastSpaces			;look for multiple spaces
	cmp.b	d2,d0				;is "Return" found ?
	beq	EndArguments			;"Return", end reached ->EndArguments
	bra	WrongArguments			;otherwise ->WrongArguments

EndSpace
	clr.b	(a1)+				;set null-byte into buffer

MoreLastSpaces
	move.b	(a2)+,d0
	cmp.b	d3,d0				;is next "Space" found ? (more spaces posible)
	beq	MoreLastSpaces			;look for multiple spaces

	cmp.b	d1,d0				;is " char. found ?
	beq	CheckDoubleQuote
	cmp.b	d2,d0				;is "Return" found ?
	beq	EndArguments			;"Return", end reached ->EndArguments
NextSpace
	move.b	d0,(a1)+			;into buffer
	move.b	(a2)+,d0
	cmp.b	d3,d0				;is next "Space" found ?
	beq	EndSpace
	cmp.b	d1,d0				;is " char. found ?
	beq	WrongArguments			;no Quote in middle of string ('file"name' or 'filename"' for example)
	cmp.b	d2,d0				;is "Return" found ?
	beq	EndArguments			;"Return", end reached ->EndArguments
	bra	NextSpace

EndArguments

	clr.w	(a1)				;set 2nd null-byte into buffer, terminates whole buffer
						;.w needed, only if comes from NextSpace routine !

********End parsing Shell (CLI) arguments************************************
* Now, in ReadCommandBuf is the optimized parsed commandline, ready to use.
*
* Only you have to do, is reading to 1st null-byte for 1st 'argument', 2nd null-byte
* for 2nd argument and so on. When you reached the double null-byte, no more 'arguments'.
* Important, all code above and to bottom is needed. Use the code to workout in your own
* programs.
*****************************************************************************

*********Begin 2nd parsing Shell (CLI) arguments************************************
*Extract options: SEARCH required, DIR required, SAVEDIR, BUFFER=, DELAY=, EXACT, CASE, QUIET, THRU and only
*REPLACE if THRU was found.

	clr.l	36(a4)				;put NULL for REPLACE, overwrite later if found

	move.l	a3,d3				;save address new Shellcommandline
	bra	SEARCH

NextArgument2
	tst.b	(a3)+
	bne	NextArgument2
	tst.b	(a3)				;test for 2nd null-byte, end reached, no SEARCH found
	beq	WrongArguments			;WrongArguments, because SEARCH is required !

SEARCH
	cmp.l	#"SEAR",(a3)			;"SEAR"
	bne	NextArgument2
	add.l	#4,a3
	cmp.w	#"CH",(a3)			;"CH"
	bne	NextArgument2
	tst.b	2(a3)
	bne	NextArgument2

;found SEARCH
	add.l	#3,a3
	tst.b	(a3)				;test for 2nd null-byte, end reached, no SEARCH base !!
	beq	WrongArguments			;WrongArguments, because SEARCH must followed by a name
	move.l	a3,24(a4)			;store SEARCH base

dir
	move.l	d3,a3				;refresh Shellcommandline
	bra	DIR

NextArgument
	tst.b	(a3)+
	bne	NextArgument
	tst.b	(a3)				;test for 2nd null-byte, end reached, no DIR found
	beq	WrongArguments			;WrongArguments, because DIR is required !

DIR
	cmp.l	#$44495200,(a3)			;"DIR" + NULL-byte
	bne	NextArgument

;found DIR

	add.l	#4,a3
	tst.b	(a3)				;test for 2nd null-byte, end reached, no DIR base !!
	beq	WrongArguments			;WrongArguments, because DIR must followed by a name
	move.l	a3,20(a4)			;store DIR base

savedir
	move.l	d3,a3				;refresh Shellcommandline
	bra	SAVEDIR

NextArgument3
	tst.b	(a3)+
	bne	NextArgument3
	tst.b	(a3)				;test for 2nd null-byte, end reached, no SAVEDIR found
	bne	SAVEDIR				;
	clr.l	28(a4)				;put NULL, no SAVEDIR found
	bra	buffer				;to next buffer

SAVEDIR
	cmp.l	#"SAVE",(a3)			;"SAVE"
	bne	NextArgument3
	add.l	#4,a3
	cmp.l	#$44495200,(a3)			;"DIR" + NULL-byte
	bne	NextArgument3

;found SAVEDIR
	add.l	#4,a3
	tst.b	(a3)				;test for 2nd null-byte, end reached, no SAVEDIR base !!
	beq	WrongArguments			;WrongArguments, because SAVEDIR must followed by a name
	move.l	a3,28(a4)			;store SAVEDIR base

buffer
	move.l	d3,a3				;refresh Shellcommandline
	bra	BUFFER

NextArgument4
	tst.b	(a3)+
	bne	NextArgument4
	tst.b	(a3)				;test for 2nd null-byte, end reached, no BUFFER= found
	beq	BUFFERdefault			;

BUFFER
	cmp.l	#"BUFF",(a3)			;"BUFF"
	bne	NextArgument4
	add.l	#4,a3
	cmp.w	#"ER",(a3)			;"ER"
	bne	NextArgument4
	add.l	#2,a3
	cmp.b	#"=",(a3)			;"="
	bne	NextArgument4

;found BUFFER=

	clr.b	(a3)+				;make null-byte from "=" to speedup BUFFERnumber routine

BUFFERend
	tst.b	(a3)+				;search end of "BUFFER=" for processing number
	bne	BUFFERend
	sub.l	#1,a3				;correct, set on last null-byte

	moveq	#0,d4				;becomes total decimal number
	moveq	#1,d0				;first decimal Power

BUFFERnumber
	moveq	#0,d1				;d1 clear
	move.b	-(a3),d1			;first ASCII represent digit in d1
	beq	BUFFEREndbuffer
	subi.w	#48,d1
	bmi	WrongArguments			;negative: no number ->WrongArguments
	subi.w	#10,d1
	bpl	WrongArguments			;positive: no number ->WrongArguments
	addi.w	#10,d1				;make number readble by machine code
	mulu.l	d0,d1				;result as .l in d1
	add.l	d1,d4				;adds to total decimal number
;	mulu.l	#10,d0				;d0 *10  ->Optimized with follow 4 lines:
	move.l	d0,d2				;Optimized: mulu.l  #10,d0
	lsl.l	#2,d2				;Optimized: mulu.l  #10,d0
	add.l	d2,d0				;Optimized: mulu.l  #10,d0
	add.l	d0,d0				;Optimized: mulu.l  #10,d0
	bra	BUFFERnumber			;next digit

BUFFEREndbuffer

	move.l	d4,d2
	beq	BUFFERdefault			;is 0 ? then use default, don't use null as BUFFER !

LookLong
	lsr.l	#1,d2				;d2/2 for longwordsize
	bcs	MakeLong              		;Carry set, bit was set ->MakeLong
	lsr.l	#1,d2				;d2/2 for longwordsize
	bcc	IsLong				;Carry clear, bit was clear ->IsLong
MakeLong
;make d4 longword aligned
	add.l	#1,d4
	move.l	d4,d2
	bra	LookLong
IsLong
	move.l	d4,32(a4)			;store BUFFER value (now longword alligned)
	bra	delay

BUFFERdefault
	move.l	#8192,32(a4)			;use 8192 bytes (longword alligned) as default

delay
	move.l	d3,a3				;refresh Shellcommandline
	bra	DELAY

NextArgument10
	tst.b	(a3)+
	bne	NextArgument10
	tst.b	(a3)				;test for 2nd null-byte, end reached, no DELAY= found
	beq	DELAYdefault			;

DELAY
	cmp.l	#"DELA",(a3)			;"DELA"
	bne	NextArgument10
	add.l	#4,a3
	cmp.w	#"Y=",(a3)			;"Y="
	bne	NextArgument10
	add.l	#1,a3

;found DELAY=

	clr.b	(a3)+				;make null-byte from "=" to speedup DELAYnumber routine

DELAYend
	tst.b	(a3)+				;search end of "DELAY=" for processing number
	bne	DELAYend
	sub.l	#1,a3				;correct, set on last null-byte

	moveq	#0,d4				;becomes total decimal number
	moveq	#1,d0				;first decimal Power

DELAYnumber
	moveq	#0,d1				;d1 clear
	move.b	-(a3),d1			;first ASCII represent digit in d1
	beq	DELAYEndbuffer
	subi.w	#48,d1
	bmi	WrongArguments			;negative: no number ->WrongArguments
	subi.w	#10,d1
	bpl	WrongArguments			;positive: no number ->WrongArguments
	addi.w	#10,d1				;make number readble by machine code
	mulu.l	d0,d1				;result as .l in d1
	add.l	d1,d4				;adds to total decimal number
;	mulu.l	#10,d0				;d0 *10  ->Optimized with follow 4 lines:
	move.l	d0,d2				;Optimized: mulu.l  #10,d0
	lsl.l	#2,d2				;Optimized: mulu.l  #10,d0
	add.l	d2,d0				;Optimized: mulu.l  #10,d0
	add.l	d0,d0				;Optimized: mulu.l  #10,d0
	bra	DELAYnumber			;next digit

DELAYEndbuffer

	move.l	d4,52(a4)			;store DELAY value
	bra	exact				;

DELAYdefault
	move.l	#0,52(a4)			;no DELAY= found, then use value 0 as default

exact
	move.l	d3,a3				;refresh Shellcommandline
	bra	EXACT

NextArgument5
	tst.b	(a3)+
	bne	NextArgument5
	tst.b	(a3)				;test for 2nd null-byte, end reached, no EXACT found
	bne	EXACT				;
	clr.w	40(a4)				;store EXACT flag=FALSE (0)
	bra	quiet
EXACT
	cmp.l	#"EXAC",(a3)			;"EXAC"
	bne	NextArgument5
	add.l	#4,a3
	cmp.w	#$5400,(a3)			;"T+NULL" T=84 decimal = $54 hex.
	bne	NextArgument5

;found EXACT
	move.w	#TRUE,40(a4)			;store EXACT flag=TRUE (-1)

quiet
	move.l	d3,a3				;refresh Shellcommandline
	bra	QUIET

NextArgument7
	tst.b	(a3)+
	bne	NextArgument7
	tst.b	(a3)				;test for 2nd null-byte, end reached, no QUIET found
	bne	QUIET				;
	clr.w	44(a4)				;store QUIET flag=FALSE (0)
	bra	case
QUIET
	cmp.l	#"QUIE",(a3)			;"QUIE"
	bne	NextArgument7
	add.l	#4,a3
	cmp.w	#$5400,(a3)			;"T+NULL" T=84 decimal = $54 hex.
	bne	NextArgument7

;found QUIET
	move.w	#TRUE,44(a4)			;store QUIET flag=TRUE (-1)

case
	move.l	d3,a3				;refresh Shellcommandline
	bra	CASE

NextArgument6
	tst.b	(a3)+
	bne	NextArgument6
	tst.b	(a3)				;test for 2nd null-byte, end reached, no CASE found
	bne	CASE				;
	clr.w	42(a4)				;store CASE flag=FALSE (0)

;case insensetive precalculation (put in buffer reverseCASE reversed case char. for later use)
	move.l	24(a4),a0			;SEARCH base
	move.l	104(a4),a1			;reversed char. from SEARCH to use in case insensitive routines
	bra	reverseCASEloop

sameCHAR
	move.b	-1(a0),(a1)+			;same char. (no reversed case char.)
;	add.l	#1,a1				;Niet gebruiken !! buggy !!

reverseCASEloop
	moveq	#0,d0				;d0 clear
	move.b	(a0)+,d0			;SEARCH base
	beq	thru				;end reached
;look if d0 was lowercase
	subi.w	#97,d0
	bmi	uppercase			;negative: no lowercase ->uppercase
	subi.w	#26,d0
	bpl	intcase				;positive: no lowercase&uppercase ->intcase
	addi.w	#91,d0				;make uppercase
	move.b	d0,(a1)+			;and in reverseCASE (holds now reversed case char.)
	bra	reverseCASEloop

uppercase
	addi.w	#32,d0				;
	bmi	sameCHAR			;negative: no lower&uppercase ->sameCHAR
	subi.w	#26,d0
	bpl	sameCHAR			;positive: no lower&uppercase ->sameCHAR (no later int. case!!)
	addi.w	#123,d0				;make lowercase
	move.b	d0,(a1)+			;and in reverseCASE (holds now reversed case char.)
	bra	reverseCASEloop

intcase						;2nd international lower/upper char. routine here
	subi.w	#69,d0
	bmi	sameCHAR			;negative: no international lowercase or uppercase ->sameCHAR
;look if d0 was international lowercase
	subi.w	#32,d0
	bmi	intupper			;negative: no international lowercase ->int. uppercase
	addi.w	#192,d0				;make international uppercase
	move.b	d0,(a1)+			;and in reverseCASE (holds now reversed case char.)
	bra	reverseCASEloop

intupper
	addi.w	#256,d0				;make international lowercase
	move.b	d0,(a1)+			;and in reverseCASE (holds now reversed case char.)
	bra	reverseCASEloop

CASE
	cmp.l	#"CASE",(a3)			;"CASE"
	bne	NextArgument6
	tst.b	4(a3)				;null-byte directly after "CASE" ->was CASE
	bne	NextArgument6

;found CASE
	move.w	#TRUE,42(a4)			;store CASE flag=TRUE (-1)

thru
	move.l	d3,a3				;refresh Shellcommandline
	bra	THRU

NextArgument8
	tst.b	(a3)+
	bne	NextArgument8
	tst.b	(a3)				;test for 2nd null-byte, end reached, no THRU found
	bne	THRU				;
	clr.w	46(a4)				;store THRU flag=FALSE (0)
	bra	EndOptions			;don't look for more options ->EndOptions
THRU
	cmp.l	#"THRU",(a3)			;"THRU"
	bne	NextArgument8
	tst.b	4(a3)				;null-byte directly after "THRU" ->was THRU
	bne	NextArgument8

;found THRU
	move.w	#TRUE,46(a4)			;store THRU flag=TRUE (-1)

	move.l	d3,a3				;refresh Shellcommandline
	bra	REPLACE

NextArgument9
	tst.b	(a3)+
	bne	NextArgument9
	tst.b	(a3)				;test for 2nd null-byte, end reached, no REPLACE found
	bne	REPLACE				;
;	clr.l	36(a4)				;put NULL, no REPLACE found !!!staat bovenaan!!!
	bra	EndOptions
REPLACE
	cmp.l	#"REPL",(a3)			;"REPL"
	bne	NextArgument9
	add.l	#4,a3
	cmp.l	#$41434500,(a3)			;"ACE+NULL" hex $41 $43 $45 $00
	bne	NextArgument9

;found REPLACE
	add.l	#4,a3
	tst.b	(a3)				;test for 2nd null-byte, end reached, no REPLACE base !!
	beq	WrongArguments			;WrongArguments, because REPLACE must followed by a name
	move.l	a3,36(a4)			;store REPLACE base

EndOptions


;follow code only needed when Workbench code is present and searching is done multiple times
;because when THRU searching is done, non THRU searching can be choosen which requires clearing old THRU opcode
;	move.l	#opco2,a1			;opco2 is the place for modify code
;	move.l	#$4E714E71,(a1)			;4E71 is opcode nop (2*)



	move.l	#opco1,a0			;opco1 is the place for modify code
	move.l	#opco2,a1			;opco2 is the place for modify code

	tst.w	46(a4)				;THRU flag=TRUE (-1)
	beq	file				;if no THRU ->file (file search routines)
						;for THRUEXACT and REPLACE routines, first count SEARCH lenght
	move.l	24(a4),a2			;SEARCH base
	moveq	#-1,d1
.SEARCHlenght
	add.w	#1,d1				;d1 counter SEARCHlenght
	tst.b	(a2)+
	bne	.SEARCHlenght
	move.w	d1,84(a4)			;in SEARCH lenght

	move.l	#$6B000174,(a0)			;opcode "bmi.w	readsave" for all THRU and REPLACE routines
	tst.l	36(a4)				;REPLACE 0=no
	bne	replace				;

	tst.w	40(a4)				;EXACT flag=TRUE (-1)
	bne	isTHRUEXACT
;is THRU NOTEXACT
	tst.w	42(a4)				;CASE flag=TRUE (-1)
	bne	isTHRUCASENOTEXACT
;is THRU NOTCASE NOTEXACT
	move.l	#$60000086,(a1)			;opcode "bra.w	thruNOTCASE_NOTEXACT"
	bra	endmodify
isTHRUEXACT					;for THRUEXACT routines, first count SEARCH lenght
	tst.w	42(a4)				;CASE flag=TRUE (-1)
	bne	isTHRUCASEEXACT
;is THRU NOTCASE EXACT
	move.l	#$600000B6,(a1)			;opcode "bra.w	thruNOTCASE_EXACT"
	bra	endmodify
isTHRUCASEEXACT
	move.l	#$6000017C,(a1)			;opcode "bra.w	thruCASE_EXACT"
	bra	endmodify
isTHRUCASENOTEXACT
	move.l	#$60000152,(a1)			;opcode "bra.w	thruCASE_NOTEXACT"
	bra	endmodify


replace						;for REPLACE routines, first count REPLACE lenght
	move.l	36(a4),a2			;REPLACE base
	moveq	#-1,d2
.REPLACElenght
	add.w	#1,d2				;d2 counter REPLACElenght
	tst.b	(a2)+
	bne	.REPLACElenght
;	move.w	84(a4),d1			;SEARCH lenght in d2
						;already in d1
	sub.l	d1,d2				;substract lenght REPLACE-SEARCH
	move.l	d2,88(a4)			;in REPLACE lenght
	tst.w	40(a4)				;EXACT flag=TRUE (-1)
	bne	isREPLACEEXACT
;is REPLACE NOTEXACT
	tst.w	42(a4)				;CASE flag=TRUE (-1)
	bne	isREPLACECASENOTEXACT
;is REPLACE NOTCASE NOTEXACT
	move.l	#$60000206,(a1)			;opcode "bra.w	REPLACENOTCASE_NOTEXACT"
	bra	endmodify
isREPLACEEXACT					;for REPLACEEXACT routines, first count SEARCH lenght
	tst.w	42(a4)				;CASE flag=TRUE (-1)
	bne	isREPLACECASEEXACT
;is REPLACE NOTCASE EXACT
	move.l	#$600002DA,(a1)			;opcode "bra.w	REPLACENOTCASE_EXACT" was 600002D8
	bra	endmodify
isREPLACECASEEXACT
	move.l	#$60000550,(a1)			;opcode "bra.w	REPLACECASE_EXACT" was 60000550
	bra	endmodify
isREPLACECASENOTEXACT
	move.l	#$6000049C,(a1)			;opcode "bra.w	REPLACECASE_NOTEXACT" was 6000049A
	bra	endmodify




file						;threat here for the several file search routines
	tst.w	42(a4)				;CASE flag=TRUE (-1)
	bne	isCASE
	tst.w	40(a4)				;EXACT flag=TRUE (-1)
	bne	isNOTCASEEXACT
;is NOTCASE NOTEXACT
;	move.l	#$6B000036,(a0)			;opcode "bmi.w	fileNOTCASE_NOTEXACT"
	move.w	#$6B36,(a0)			;opcode "bmi.b	fileNOTCASE_NOTEXACT"
	bra	endfilemodify
isNOTCASEEXACT
	move.w	#$6B62,(a0)			;opcode "bmi.b	fileNOTCASE_EXACT"
	bra	endfilemodify

isCASE
	tst.w	40(a4)				;EXACT flag=TRUE (-1)
	bne	isCASEEXACT
;is CASE NOTEXACT
	move.l	#$6B000096,(a0)			;opcode "bmi.w	fileCASE_NOTEXACT"
	bra	endfilemodify
isCASEEXACT
	move.l	#$6B0000B4,(a0)			;opcode "bmi.w	fileCASE_EXACT"

endfilemodify

endmodify



;	move.l	(_SYSBase).w,a6
	jsr	_LVOCacheClearU(a6)		;CacheClearU()          V36 or higher (Release 2.0)


;Nieuwe snelle addressing for faster SEARCH and reverseCASE
	move.l	24(a4),a1			;SEARCH base
	move.b	(a1)+,d5			;first SEARCH in d5 to speedup find routines
	move.l	a1,24(a4)			;and 2e char. back
	move.l	a1,d4				;and in d4

	move.l	104(a4),a0			;reversed char. from SEARCH
	move.b	(a0)+,d6			;first reverseCASE in d6 to speedup find routines
	move.l	a0,104(a4)			;and 2e char. back




*****************************************************************************
** Here begins the core Subdir scanning routine                            **
*****************************************************************************
* The memory block lenght is defined in BUFFER, which must be always longword aligned (otherwise crash)
* The memory block is as follows:
* 1 part 1040 bytes for FileInfoBlock for save routine
* 2 part lenght SAVEDIR+filelen to store save path+matched file used for save routine
* 3 part begins pathbuf, used to store path and subdirs in for dirscanning.
* the end of pathbuf is also used stackwise to put (sub)dir, lock, FileInfoBlock memory bases in for dirscanning.

;Path buffer memory allocation (holds path and later all subdirs !)

	move.l	32(a4),d0			;BUFFER value is lenght
	move.l	#MEMF_PUBLIC,d1			;memory type public
;	move.l	(_SYSBase).w,a6			;
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1)
	move.l	d0,56(a4)			;one FileInfoBlock for save routine
	beq	ioerror				;not succesful ? ->ioerror

	move.l	d0,a5				;we gonna use end pathbuf stack wise
	add.l	32(a4),a5			;BUFFER value is lenght
	clr.l	-(a5)				;first put NULL, as a marker
	add.l	#1040,d0			;reserve one FileInfoBlock for save routine

;here SAVEDIR get own (2e) part of the buffer
	move.l	28(a4),a3			;startaddress SAVEDIR in a3
	tst.l	(a3)				;look if there's SAVEDIR
	beq	nosavedir
	move.l	d0,60(a4)			;in new SAVEDIR
	move.l	d0,a1				;and in a1

	moveq	#0,d3
SAVEDIRcopy
	add.w	#1,d3				;d3 savedir lenght counter (one to many, is harmless)
	move.b	(a3)+,(a1)+			;
	bne	SAVEDIRcopy			;0 -> search for null-byte

	sub.l	#1,a1				;set a1 at null-byte

	cmp.b	#":",-1(a1)			;is root dir ?
	beq	findendSAVEDIR
	move.b	#"/",(a1)+			;add / char.
findendSAVEDIR
;	clr.b	(a1)				;TEST, alleen voor TESTprint nodig
	move.l	a1,64(a4)			;in new SAVEDIR, pointer at end for appending filename

	add.l	#filelen,d3			;add filelen to savedir for own buffer
	add.l	d3,d0				;finally, here begins the buffer used for dir scanning (pathbuf)

nosavedir
	move.l	d0,48(a4)			;in pathbuf
	move.l	d0,a1

;	bra	TESTprint			;TEST


;fill Path buffer with path (dirname)

	move.l	20(a4),a3			;DIR is first device or drawer scanning in
pathcopy
	move.b	(a3)+,(a1)+			;
	bne	pathcopy			;0 -> search for null-byte

	sub.l	#1,a1
	move.l	a1,-(a5)			;(a5) holds end path, used for later. (searching in subdirs)


;-----------TEST begin print pathbuf------------

;	move.l	48(a4),a1			;pathbuf
;	move.l	a1,d2				;filename address in d2
;	moveq	#0,d3
;.pathname
;	addq.w	#1,d3				;d3 filename lenght counter
;	tst.b	(a1)+
;	bne	.pathname

;	move.l	outputhandle,d1			;outputhandle
;	move.l	_DOSBase(pc),a6
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;;"Return"

;	move.l	outputhandle,d1			;outputhandle
;	move.l	#return,d2
;	move.l	#1,d3
;;	move.l	_DOSBase(pc),a6
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;-----------TEST end print pathbuf--------------


*first lock the desired directory or device:

	move.l	48(a4),d1			;pathbuf
	moveq	#SHARED_LOCK,d2			;SHARED_LOCK, File is readable by others. EXCLUSIVE_LOCK, No other access allowed (gives: no such file)
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOLock(a6)			;Lock(name,type)(d1/d2)
	move.l	d0,-(a5)			;locksav
	beq	ioerror				;can not lock ->ioerror

;FileInfoBlock memory allocation

	move.l	#1040,d0			;lenght FileInfoBlock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6			;
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1)
;	bsr	output32			;TEST

	move.l	d0,-(a5)			;memory base at stack
	beq	ioerror				;not succesful ? ->ioerror

	clr.l	-12(a5)				;make next NULL as a marker
	move.l	(a4),a6				;_DOSBase

examine ;(inquire file):

	move.l	4(a5),d1			;locksav in d1
	move.l	(a5),d2				;fileInfoBlock in d2
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOExamine(a6)			;Examine(lock,fileInfoBlock)(d1/d2) >don't trash d2 !!
	beq	ioerror				;not succesful ->ioerror

*First is always device or drawer itself ! (no file) Only by root !! seems harmless.
;	move.l	4(a7),d1			;locksav in d1
;	move.l	(a7),d2
;	jsr	_LVOExNext(a6)			;ExNext(lock,fileInfoBlock)(d1/d2)
;	tst.l	d0				;find it ?
;	beq	ioerror				;no: end

loop:

	move.l	4(a5),d1			;locksav in d1
	move.l	(a5),d2				;fileInfoBlock in d2
	jsr	_LVOExNext(a6)			;ExNext(lock,fileInfoBlock)(d1/d2) >don't trash d2 !!
	tst.l	d0				;find it ?
	bne	fileordir
	move.l	4(a5),d1			;locksav in d1
	jsr	_LVOUnLock(a6)			;UnLock(lock)(d1)
	add.l	#12,a5				;parent dir
	tst.l	(a5)				;is NULL ? then end root reached !
	bne	loop
;	bra	ioerror
	bra	freeCommandBuf			;end, dirscanning finished, to freeCommandBuf


************************************************


fileordir

;	move.l	(a5),a3
	move.l	d2,a3				;fileInfoBlock already in d2
	add.l	#fib_FileName,a3		;set on fib_FileName
	tst.l	-4(a3)				;If < 0, then a plain file
opco1:
	nop
	nop
;	bmi	readsave		;
;	bopt	OD6-
;	bmi	fileCASE_EXACT
;	bopt	OD6+

;append new subdir

	move.l	8(a5),a1			;end previous path in a1
	cmp.b	#":",-1(a1)			;is root dir ?
	beq	lookalloc
	move.b	#"/",(a1)+			;add / char.
lookalloc
	tst.l	-12(a5)				;was there're already FileInfoBlock allocated ?
	beq	pathcopy			;0 then no ->pathcopy

dircopy
	move.b	(a3)+,(a1)+			;
	bne	dircopy				;0 -> search for null-byte

	sub.l	#1,a1
	move.l	a1,-(a5)			;(a5) holds end path, used for later. (searching in subdirs)

	move.l	48(a4),d1			;pathbuf
	moveq	#SHARED_LOCK,d2			;SHARED_LOCK, File is readable by others. EXCLUSIVE_LOCK, No other access allowed (gives: no such file)
;	move.l	_DOSBase(pc),a6
	jsr	_LVOLock(a6)			;Lock(name,type)(d1/d2)
	move.l	d0,-(a5)			;locksav
	beq	ioerror				;can not lock ->ioerror

	sub.l	#4,a5				;use old FileInfoBlock

;-----------TEST begin print pathbuf------------

;	move.l	48(a4),a1			;pathbuf
;	move.l	a1,d2				;filename address in d2
;	moveq	#0,d3
;.pathname
;	addq.w	#1,d3				;d3 filename lenght counter
;	tst.b	(a1)+
;	bne	.pathname

;	move.l	outputhandle,d1			;outputhandle
;	move.l	_DOSBase(pc),a6
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;;"Return"

;	move.l	outputhandle,d1			;outputhandle
;	move.l	#return,d2
;	move.l	#1,d3
;;	move.l	_DOSBase(pc),a6
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;-----------TEST end print pathbuf--------------

	bra	examine				;to examine


***********************************************************
**********file*********************************************
isfile						;a3 holds fib_FileName

*********found code NOTCASE, NOTEXACT***************
fileNOTCASE_NOTEXACT
;	bra	UsageText			;TEST of modify code goed werkt
	move.l	a3,a2				;filename address in a2

firstNOTCASE_NOTEXACT				;compare first char. (faster routine)
	move.b	(a2)+,d3			;filename in d3
	beq	loop				;end filename ->loop
	cmp.b	d5,d3				;compare SEARCH, filename
	beq	startNOTCASE_NOTEXACT
;look if d3 was reversed case
	cmp.b	d6,d3				;compare reverseCASE, filename (#2 ~4)
	bne	firstNOTCASE_NOTEXACT		;first char. isn't same ->firstNOTCASE_NOTEXACT
startNOTCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

loopNOTCASE_NOTEXACT				;(addq #1,a0   #2 ~8)
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchfile			;found ->matchfile
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	move.b	(a2)+,d3			;filename in d3
	beq	loop				;
	cmp.b	d0,d3				;compare SEARCH, filename
	beq	loopNOTCASE_NOTEXACT		;
;look if d3 was reversed case
	cmp.b	d2,d3				;compare reverseCASE, filename (#2 ~4)
	bne	firstNOTCASE_NOTEXACT
	bra	loopNOTCASE_NOTEXACT		;was same

*********found code NOTCASE, EXACT***************
fileNOTCASE_EXACT
;	bra	UsageText			;TEST of modify code goed werkt
	move.l	a3,a2				;filename address in a2

;compare first char. (faster routine)
	move.b	(a2)+,d3			;filename in d3
	cmp.b	d5,d3				;compare SEARCH, filename
	beq	startNOTCASE_EXACT
;look if d3 was reversed case
	cmp.b	d6,d3				;compare reverseCASE, filename (#2 ~4)
	bne	loop				;first char. isn't same ->loop
startNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

loopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	endNOTCASE_EXACT		;
	move.b	(a0)+,d1			;reverseCASE in d1 (holds reversed case char. of SEARCH)
	move.b	(a2)+,d3			;filename in d3
	beq	loop				;
	cmp.b	d0,d3				;compare SEARCH, filename
	beq	loopNOTCASE_EXACT		;
;look if d3 was reversed case
	cmp.b	d1,d3				;compare reverseCASE, filename
	bne	loop				;don't match ->loop
	bra	loopNOTCASE_EXACT		;was same

endNOTCASE_EXACT
	tst.b	(a2)				;if NULL then found
	beq	matchfile			;found ->matchfile
	bra	loop				;otherwise, go on with dir scanning

*********found code CASE, NOTEXACT***************
fileCASE_NOTEXACT

;	bra	UsageText			;TEST of modify code goed werkt
	move.l	a3,a2				;filename address in a2

firstCASE_NOTEXACT				;compare first char. (faster routine)
	move.b	(a2)+,d3			;filename in d3
	beq	loop				;end filename ->loop
	cmp.b	d5,d3				;compare SEARCH, filename
	bne	firstCASE_NOTEXACT		;first char. isn't same ->firstCASE_NOTEXACT
startCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base

loopCASE_NOTEXACT
	move.b	(a1)+,d0			;~8 #2
	beq	matchfile			;found ->matchfile
	move.b	(a2)+,d3			;~8 #2
	beq	loop				;~8 not taken, ~10 taken
	cmp.b	d0,d3				;~4 #2
	bne	firstCASE_NOTEXACT
	bra	loopCASE_NOTEXACT

*********found code CASE, EXACT***************
fileCASE_EXACT

;	bra	UsageText			;TEST of modify code goed werkt
	move.l	a3,a2				;filename address in a2

;compare first char. (faster routine)
	move.b	(a2)+,d3			;filename in d3
	cmp.b	d5,d3				;compare SEARCH, filename
	bne	loop				;first char. isn't same ->loop
startCASE_EXACT
	move.l	d4,a1				;SEARCH base

loopCASE_EXACT
	move.b	(a1)+,d0			;~8
	beq	endCASE_EXACT			;~8 not taken, ~10 taken
	cmp.b	(a2)+,d0			;~8
	bne	loop				;~8 not taken, ~10 taken
	bra	loopCASE_EXACT
endCASE_EXACT
	tst.b	(a2)				;if NULL then found
	beq	matchfile			;found ->matchfile
	bra	loop				;otherwise, go on with dir scanning


**Hier nog in ontwikkeling END**************


**Voorbeeld code---------------------
*
*	move.l	50(a4),d2			;~16 (#4)SEARCH lenght
*
*Com3	cmpm.b	(a3)+,(a1)+			;~12 (#2)
*	dbne	d2,Com3				;~10=false ~12=true ~14=expired (#4)
*	bne	NextArgument3			;~8 not taken, ~10 taken (#2 short, #4 word)
**Voorbeeld code----------------------

*******************************************************************
*** BEGIN match file						***
*******************************************************************
;routine to put text from matched file. First look if needed for Shell or Workbench
;by Shell routine, simply print the information in (Shell) window
;by Workbench, put text in requester or list
;a3 contains the filename address

matchfile

	tst.l	-4(a4)				;WBStartup Message
	beq	matchfileCLI			;for Shell
;put here routine for Workbench



matchfileCLI

	tst.w	44(a4)				;QUIET
	bne	endprintpathbuf			;if yes (-1) ->endprintpathbuf

printpathbuf

	move.l	8(a5),a1			;end path in a1
	clr.b	(a1)				;clear old subdir(s), only for matchfile, gives correct path

	move.l	48(a4),a1			;pathbuf
	move.l	a1,d2				;address in d2 for later _LVOWrite
	moveq	#0,d3
.pathname
	addq.w	#1,d3				;d3 path lenght counter
	tst.b	(a1)+
	bne	.pathname
	subq.w	#1,d3				;correct it

	sub.l	#1,a1				;set a1 at null-byte

	cmp.b	#":",-1(a1)			;is root dir ?
	beq	printmatched
	move.b	#"/",(a1)+			;add / char.
	addq.w	#1,d3
printmatched

	move.l	4(a4),d1			;outputhandle
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;print filename
	move.l	a3,a0				;filename address in a0
	move.l	a3,d2				;filename address in d2 for Write

	moveq	#0,d3
.filename
	addq.w	#1,d3				;d3 filename lenght counter
	tst.b	(a0)+
	bne	.filename
	subq.w	#1,d3				;correct it

	move.l	4(a4),d1			;outputhandle
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

endprintpathbuf
;look for different flags, THRU, SAVEDIR, QUIET
	tst.w	46(a4)				;THRU flag=TRUE (-1)
	beq	noTHRU
	tst.l	28(a4)				;SAVEDIR
	bne	save				;if yes (-1) ->save (THRU requires save routine)
	bra	printreturnTHRU			;
noTHRU
	tst.l	28(a4)				;SAVEDIR
	bne	readsave			;if yes (-1) ->readsave

printreturn
	tst.w	44(a4)				;QUIET
	bne	loop				;if yes (-1) ->loop

	move.l	4(a4),d1			;outputhandle
	move.l	#return,d2
	move.l	#1,d3
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

	bra	loop				;go on with dirscanning

printreturnTHRU
	tst.w	44(a4)				;QUIET
	bne	CanNotOpenFile			;if yes (-1) ->CanNotOpenFile (freed memory, unlock)

	move.l	4(a4),d1			;outputhandle
	move.l	#return,d2
	move.l	#1,d3
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

	bra	CanNotOpenFile			;CanNotOpenFile (freed memory, unlock)


*******************************************************************
*** END match file						***
*******************************************************************




*******************************************************************
*** BEGIN readsave							***
*******************************************************************

readsave					;a3 contains the filename address

;	bra	UsageText			;TEST of modify code goed werkt

;append filename

	move.l	a3,a0				;filename in a0

	move.l	8(a5),a1			;end path in a1
	cmp.b	#":",-1(a1)			;is root dir ?
	beq	appendfile
	move.b	#"/",(a1)+			;add / char.

appendfile
	move.b	(a0)+,(a1)+			;
	bne	appendfile			;0 -> search for null-byte

;-----------TEST begin print pathbuf------------

;;print pathbuf
;	move.l	48(a4),a1			;pathbuf
;	move.l	a1,d2				;address in d2
;	moveq	#0,d3
;.pathname
;	addq.w	#1,d3				;d3 filename lenght counter
;	tst.b	(a1)+
;	bne	.pathname

;	move.l	4(a4),d1			;outputhandle
;;	move.l	_DOSBase(pc),a6
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;-----------TEST end print pathbuf--------------


*------------------------------------------------------------
*---BEGIN ReadFile routine (Read file from disk)-------------

*first lock the desired file:

	move.l	48(a4),d1			;name of file to read
	moveq	#SHARED_LOCK,d2			;SHARED_LOCK, File is readable by others. EXCLUSIVE_LOCK, No other access allowed (gives: no such file)
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOLock(a6)			;Lock(name,type)(d1/d2)
	move.l	d0,76(a4)			;savelock
	bne	Examine
	bsr	ioerror
	bra	loop				;can not lock ->loop

Examine
	move.l	d0,d1				;savelock in d1
	move.l	56(a4),d2			;one FileInfoBlock for save routine
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOExamine(a6)			;Examine(lock,fileInfoBlock)(d1/d2) >don't trash d2 !!
	bne	Memreserve
	bsr	ioerror
	bra	CanNotExamine			;not succesful ->CanNotExamine

Memreserve
	move.l	d2,a0				;fileInfoBlock already in d2
	move.l	fib_Size(a0),d0			;get fib_Size (lenght file)
;	move.l	d0,d3				;in d3 here for later _LVORead, _LVOWrite and _LVOFreeMem
	move.l	d0,72(a4)			;ReadFileLength
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,68(a4)			;ReadFileBuffer
	bne	Fileopen
	bsr	ioerror
	bra	MemoryError			;not succesful ->MemoryError

Fileopen
	move.l	48(a4),d1			;name of file to open
	move.l	#MODE_READWRITE,d2		;only with shared lock, used for reading AND (!) writing
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOOpen(a6)			;Open(name,accessMode)(d1/d2)
	move.l	d0,80(a4)			;filehandle
	bne	Readfile
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile

Readfile
	move.l	d0,d1				;filehandle in d1
	move.l	68(a4),d2			;ReadFileBuffer
	move.l	72(a4),d3			;ReadFileLength
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVORead(a6)			;Read(file,buffer,length)(d1/d2/d3) >don't trash d2,d3 !!
	cmp.l	#-1,d0				;error occured ? -1=error
	bne	Fileclose
	bsr	ioerror
	move.l	80(a4),d1			;filehandle in d1
	jsr	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile

;the whole file is loaded in memory now, the pointer to the memory-area
;is in ReadFileBuffer
;the size of the file is in ReadFileLength
;the last thing we do: close file

Fileclose
	move.l	80(a4),d1			;filehandle in d1
;	move.l	_DOSbase(pc),a6
	jsr	_LVOClose(a6)		;Close(file)(d1) >don't trash d2,d3 !!

;---------EINDE read file from disk------------------------
;------save file routine here---------
opco2:						;opco2: for branch to new THRU or REPLACE routines
	nop
	nop
;	bra	REPLACECASE_EXACT		;TEST
save
	move.l	a3,a0				;a3 contains the filenameaddress
	move.l	64(a4),a1			;new SAVEDIR end

appendsave
	move.b	(a0)+,(a1)+			;
	bne	appendsave			;0 -> search for null-byte

;file open
	move.l	60(a4),d1			;new SAVEDIR
	move.l	#MODE_NEWFILE,d2		;
	jsr	_LVOOpen(a6)			;Open(name,accessMode)(d1/d2)
	move.l	d0,80(a4)			;filehandle
	bne	Savefile
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile

Savefile
	move.l	d0,d1				;filehandle in d1
	move.l	68(a4),d2			;ReadFileBuffer
	move.l	72(a4),d3			;ReadFileLength
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
	cmp.l	#-1,d0				;error occured ? -1=error
	bne	savedone
	bsr	ioerror
	bra	Saveclose
savedone
						;if from Workbench, then QUIET=-1 thus skip " saved.."
	tst.w	44(a4)				;QUIET
	bne	Saveclose			;if yes (-1) ->Saveclose (skip " saved..")

;" saved.."
	move.l	4(a4),d1			;outputhandle
	move.l	#saved,d2
	move.l	#9,d3
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

Saveclose
	move.l	80(a4),d1			;filehandle in d1
	jsr 	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!

	move.l	52(a4),d1			;DELAY
;	beq	SkipDelay			;if DELAY null ->SkipDelay
	jsr	_LVODelay(a6)			;Delay(timeout)(d1)
;SkipDelay

;-----------TEST begin print new SAVEDIR------------

;	move.l	60(a4),a1			;new SAVEDIR
;	move.l	a1,d2				;filename address in d2
;	moveq	#0,d3
;lenghtname4
;	addq.w	#1,d3				;d3 filename lenght counter
;	tst.b	(a1)+
;	bne	lenghtname4

;	move.l	4(a4),d1			;outputhandle
;	move.l	(a4),a6				;_DOSBase
;	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

;-----------TEST end print --------------

;	move.l	d2,d0			;TEST
;	bsr	output32		;TEST

CanNotOpenFile:

	move.l	68(a4),a1			;ReadFileBuffer
	move.l	72(a4),d0			;ReadFileLength
	move.l	(_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0) >don't trash d2,d3 !!

MemoryError:
CanNotExamine:

	move.l	76(a4),d1			;savelock
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOUnLock(a6)			;UnLock(lock)(d1)

CanNotLock:

	bra	loop				;

*******************************************************************
*** END save							***
*******************************************************************


*******************************************************************
*** BEGIN THRU							***
*******************************************************************
;look in TrueSearchReal6f.asm for counting occurrences in thruNOTCASE_NOTEXACT search, this routine does only first match

thruNOTCASE_NOTEXACT
;	bra	UsageText			;TEST of modify code goed werkt

						;ReadFileLength already in d3 !
;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	bra	firstthruNOTCASE_NOTEXACT	;correct file lenght counter d3 (one to little)

nextthruNOTCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
firstthruNOTCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startthruNOTCASE_NOTEXACT	;see of the rest matches ->startloopNOTCASE_NOTEXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextthruNOTCASE_NOTEXACT	;first char. isn't same ->nextthruNOTCASE_NOTEXACT

startthruNOTCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

thruloopNOTCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchfile			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	thruloopNOTCASE_NOTEXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextthruNOTCASE_NOTEXACT
	bra	thruloopNOTCASE_NOTEXACT	;was same

*****************
;look in TrueSearchReal6i.asm for counting occurrences in thruNOTCASE_EXACT search, this routine does only first match

thruNOTCASE_EXACT
;	bra	UsageText			;TEST of modify code goed werkt

;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	firststartthruNOTCASE_EXACT	;see of the rest matches ->firststartloopNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextthruNOTCASE_EXACT		;first char. isn't same ->nextthruNOTCASE_EXACT

firststartthruNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

firstthruloopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchthruNOTCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	firstthruloopNOTCASE_EXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextthruNOTCASE_EXACT
	bra	firstthruloopNOTCASE_EXACT	;was same

firstmatchthruNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	matchfile
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextthruNOTCASE_EXACT
;isthruNOTCASE_EXACT
	bra	matchfile

nothruNOTCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextthruNOTCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startthruNOTCASE_EXACT		;see of the rest matches ->startloopNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextthruNOTCASE_EXACT		;first char. isn't same ->nextthruNOTCASE_EXACT

startthruNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

thruloopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchthruNOTCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	thruloopNOTCASE_EXACT		;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextthruNOTCASE_EXACT
	bra	thruloopNOTCASE_EXACT		;was same

matchthruNOTCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nothruNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	matchfile
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextthruNOTCASE_EXACT
;isthruNOTCASE_EXACT
	bra	matchfile

*****************

thruCASE_NOTEXACT
;	bra	UsageText			;TEST of modify code goed werkt

						;ReadFileLength already in d3 !
;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	bra	firstthruCASE_NOTEXACT		;correct file lenght counter d3 (one to little)

nextthruCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
firstthruCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextthruCASE_NOTEXACT		;first char. isn't same ->nextthruCASE_NOTEXACT

startthruCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

thruloopCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchfile			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	thruloopCASE_NOTEXACT		;
	bra	nextthruCASE_NOTEXACT

*****************

thruCASE_EXACT
;	bra	UsageText			;TEST of modify code goed werkt

;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextthruCASE_EXACT		;first char. isn't same ->nextthruCASE_EXACT

firststartthruCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

firstthruloopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchthruCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextthruCASE_EXACT
	bra	firstthruloopCASE_EXACT	;was same

firstmatchthruCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	matchfile
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextthruCASE_EXACT
;isthruCASE_EXACT
	bra	matchfile

nothruCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextthruCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextthruCASE_EXACT		;first char. isn't same ->nextthruCASE_EXACT

startthruCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

thruloopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchthruCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	CanNotOpenFile			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextthruCASE_EXACT
	bra	thruloopCASE_EXACT		;was same

matchthruCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nothruCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	matchfile
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextthruCASE_EXACT
;isthruCASE_EXACT
	bra	matchfile



*******************************************************************
*** END THRU							***
*******************************************************************

*******************************************************************
*** BEGIN REPLACE						***
*******************************************************************

REPLACENOTCASE_NOTEXACT

countNOTCASE_NOTEXACT
;	bra	UsageText			;TEST of modify code goed werkt

						;ReadFileLength already in d3 !
;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	clr.l	d7				;clear d7, counter

	bra	firstcountNOTCASE_NOTEXACT	;correct file lenght counter d3 (one to little)

nextcountNOTCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountNOTCASE_NOTEXACT	;end of file ->EOFcountNOTCASE_NOTEXACT
firstcountNOTCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startcountNOTCASE_NOTEXACT	;see of the rest matches ->startcountNOTCASE_NOTEXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextcountNOTCASE_NOTEXACT	;first char. isn't same ->nextcountNOTCASE_NOTEXACT

startcountNOTCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

countloopNOTCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchcountNOTCASE_NOTEXACT	;found ->matchcount
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountNOTCASE_NOTEXACT	;end of file ->EOFcountNOTCASE_NOTEXACT
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	countloopNOTCASE_NOTEXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextcountNOTCASE_NOTEXACT
	bra	countloopNOTCASE_NOTEXACT	;was same

matchcountNOTCASE_NOTEXACT
	add.l	#1,d7				;count how much the SEARCH was found into the file
	bra	nextcountNOTCASE_NOTEXACT

EOFcountNOTCASE_NOTEXACT

	tst.l	d7				;see how much the SEARCH was found into the file
	beq	CanNotOpenFile			;null ->not found, CanNotOpenFile (freed memory, unlock)

	move.l	88(a4),d0
	bmi	wassmallerNOTCASE_NOTEXACT
	mulu.l	d7,d0				;greater memoryblock needed (or same if 0)

	add.l	72(a4),d0			;ReadFileLength+extra REPLACE
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
;greater memoryblock REPLACE
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneNOTCASE_NOTEXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

wassmallerNOTCASE_NOTEXACT			;no new (greater or same) memoryblock, instead, use old one
	neg.l	d0				;make positive
	mulu.l	d7,d0
	move.l	72(a4),d1			;ReadFileLength in d1
	sub.l	d0,d1				;ReadFileLength smaller, because REPLACE is smaller

	move.l	68(a4),96(a4)			;copy ReadFileBuffer
	move.l	d1,92(a4)			;new smaller ReadFileLength

blockdoneNOTCASE_NOTEXACT

;	bra	matchfile			;TEST

repNOTCASE_NOTEXACT
	move.l	a3,-(a7)			;a3 on stack
	move.l	96(a4),a3			;(greater/smaller) memoryblock REPLACE in a3 used to copy in
	move.l	72(a4),d3			;ReadFileLength
	move.l	68(a4),a2			;ReadFileBuffer in a2

	moveq	#0,d1				;d1
	move.w	84(a4),d1			;lenght SEARCH

	bra	firstrepNOTCASE_NOTEXACT	;correct file lenght d3 (one to little)

nextrepNOTCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFNOTCASE_NOTEXACT		;end of file ->EOFNOTCASE_NOTEXACT
firstrepNOTCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startrepNOTCASE_NOTEXACT	;see of the rest matches ->startrepNOTCASE_NOTEXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextrepNOTCASE_NOTEXACT		;first char. isn't same ->nextrepNOTCASE_NOTEXACT

startrepNOTCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

reploopNOTCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchrepNOTCASE_NOTEXACT	;found ->matchrepNOTCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFNOTCASE_NOTEXACT		;end of file ->EOF
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	reploopNOTCASE_NOTEXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextrepNOTCASE_NOTEXACT
	bra	reploopNOTCASE_NOTEXACT		;was same

matchrepNOTCASE_NOTEXACT
	sub.l	d1,a3				;copyblock back
	move.l	36(a4),a0			;REPLACE in a0
replaceNOTCASE_NOTEXACT
	move.b	(a0)+,(a3)+
	bne	replaceNOTCASE_NOTEXACT
	sub.l	#1,a3
	bra	nextrepNOTCASE_NOTEXACT

EOFNOTCASE_NOTEXACT

	move.l	(a7)+,a3			;a3 restored
	bra	finiREPLACE

*****************
REPLACENOTCASE_EXACT

;	bra	UsageText			;TEST of modify code goed werkt

;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	clr.l	d7

	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	firststartcountNOTCASE_EXACT	;see of the rest matches ->firststartcountNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextcountNOTCASE_EXACT		;first char. isn't same ->nextcountNOTCASE_EXACT

firststartcountNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

firstcountloopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchcountNOTCASE_EXACT	;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	firstcountloopNOTCASE_EXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextcountNOTCASE_EXACT
	bra	firstcountloopNOTCASE_EXACT	;was same

firstmatchcountNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastcountNOTCASE_EXACT
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextcountNOTCASE_EXACT
;iscountNOTCASE_EXACT
	add.l	#1,d7
	bra	nextcountNOTCASE_EXACT

nocountNOTCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextcountNOTCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startcountNOTCASE_EXACT		;see of the rest matches ->startloopNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextcountNOTCASE_EXACT		;first char. isn't same ->nextcountNOTCASE_EXACT

startcountNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

countloopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchcountNOTCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	countloopNOTCASE_EXACT		;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextcountNOTCASE_EXACT
	bra	countloopNOTCASE_EXACT		;was same

matchcountNOTCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nocountNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastcountNOTCASE_EXACT
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextcountNOTCASE_EXACT
;iscountNOTCASE_EXACT
	add.l	#1,d7
	bra	nextcountNOTCASE_EXACT

waslastcountNOTCASE_EXACT
	add.l	#1,d7

EOFcountNOTCASE_EXACT
	tst.l	d7
	beq	CanNotOpenFile

	move.l	88(a4),d0			;for replace EXACT routines, use always new memoryblock
	bmi	wassmallerNOTCASE_EXACT

	mulu.l	d7,d0				;greater memoryblock needed (or same if 0)

	add.l	72(a4),d0			;ReadFileLength+extra REPLACE
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
;greater memoryblock REPLACE
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneNOTCASE_EXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

wassmallerNOTCASE_EXACT				;new smaller memoryblock, can't use old one for replace EXACT
	neg.l	d0				;make positive
	mulu.l	d7,d0
	move.l	72(a4),d1			;ReadFileLength in d1
	sub.l	d0,d1				;ReadFileLength smaller, because REPLACE is smaller
	move.l	d1,d0

;new smaller memoryblock REPLACE (needed for EXACT routine)
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneNOTCASE_EXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

blockdoneNOTCASE_EXACT
repNOTCASE_EXACT
	move.l	a3,-(a7)			;a3 on stack
;	move.l	96(a4),a3			;(greater/smaller) memoryblock REPLACE in a3 used to copy in
	move.l	d0,a3				;96(a4) already in d0
	move.l	72(a4),d3			;ReadFileLength
	move.l	68(a4),a2			;ReadFileBuffer in a2


	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	beq	firststartrepNOTCASE_EXACT	;see of the rest matches ->firststartrepNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextrepNOTCASE_EXACT		;first char. isn't same ->nextrepNOTCASE_EXACT

firststartrepNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

firstreploopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchrepNOTCASE_EXACT	;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	firstreploopNOTCASE_EXACT	;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextrepNOTCASE_EXACT
	bra	firstreploopNOTCASE_EXACT	;was same

firstmatchrepNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastrepNOTCASE_EXACT
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextrepNOTCASE_EXACT
;isrepNOTCASE_EXACT
	bra	copyrepNOTCASE_EXACT

norepNOTCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextrepNOTCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	beq	startrepNOTCASE_EXACT	;see of the rest matches ->startloopNOTCASE_EXACT
;look if d2 was reversed case
	cmp.b	d6,d2				;compare reverseCASE, file (#2 ~4)
	bne	nextrepNOTCASE_EXACT	;first char. isn't same ->nextrepNOTCASE_EXACT

startrepNOTCASE_EXACT
	move.l	d4,a1				;SEARCH base
	move.l	104(a4),a0			;reversed char. from SEARCH

reploopNOTCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchrepNOTCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFNOTCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a0)+,d2			;reverseCASE in d2 (holds reversed case char. of SEARCH) (#2 ~8)
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	beq	reploopNOTCASE_EXACT		;
;look if -1(a2) was reversed case
	cmp.b	-1(a2),d2			;compare file, reverseCASE
	bne	nextrepNOTCASE_EXACT
	bra	reploopNOTCASE_EXACT		;was same

matchrepNOTCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	norepNOTCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastrepNOTCASE_EXACT
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextrepNOTCASE_EXACT
;isrepNOTCASE_EXACT

copyrepNOTCASE_EXACT
	sub.l	d1,a3				;copyblock back
	add.l	#1,a3				;correct mischien, nog kijken !
	move.l	36(a4),a0			;REPLACE in a0
replaceNOTCASE_EXACT
	move.b	(a0)+,(a3)+
	bne	replaceNOTCASE_EXACT
	sub.l	#1,a3
	bra	nextrepNOTCASE_EXACT

waslastrepNOTCASE_EXACT
	sub.l	d1,a3				;copyblock back
	add.l	#1,a3				;correct mischien, nog kijken !
	move.l	36(a4),a0			;REPLACE in a0
lastreplaceNOTCASE_EXACT
	move.b	(a0)+,(a3)+
	bne	lastreplaceNOTCASE_EXACT

EOFNOTCASE_EXACT

	move.l	(a7)+,a3			;a3 restored
	bra	finiREPLACE


*****************
REPLACECASE_NOTEXACT

;	bra	UsageText			;TEST of modify code goed werkt

						;ReadFileLength already in d3 !
;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	clr.l	d7				;clear d7, counter

	bra	firstcountCASE_NOTEXACT		;correct file lenght counter d3 (one to little)

nextcountCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountCASE_NOTEXACT		;end of file ->EOFcountCASE_NOTEXACT
firstcountCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextcountCASE_NOTEXACT		;first char. isn't same ->nextcountCASE_NOTEXACT

startcountCASE_NOTEXACT				;see of the rest matches
	move.l	d4,a1				;SEARCH base

countloopCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchcountCASE_NOTEXACT		;found ->matchcount
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountCASE_NOTEXACT		;end of file ->EOFcountCASE_NOTEXACT
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextcountCASE_NOTEXACT
	bra	countloopCASE_NOTEXACT		;was same

matchcountCASE_NOTEXACT
	add.l	#1,d7				;count how much the SEARCH was found into the file
	bra	nextcountCASE_NOTEXACT

EOFcountCASE_NOTEXACT

	tst.l	d7				;see how much the SEARCH was found into the file
	beq	CanNotOpenFile			;null ->not found, CanNotOpenFile (freed memory, unlock)

	move.l	88(a4),d0
	bmi	wassmallerCASE_NOTEXACT
	mulu.l	d7,d0				;greater memoryblock needed (or same if 0)

	add.l	72(a4),d0			;ReadFileLength+extra REPLACE
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
;greater memoryblock REPLACE
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneCASE_NOTEXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

wassmallerCASE_NOTEXACT				;no new (greater or same) memoryblock, instead, use old one
	neg.l	d0				;make positive
	mulu.l	d7,d0
	move.l	72(a4),d1			;ReadFileLength in d1
	sub.l	d0,d1				;ReadFileLength smaller, because REPLACE is smaller

	move.l	68(a4),96(a4)			;copy ReadFileBuffer
	move.l	d1,92(a4)			;new smaller ReadFileLength

blockdoneCASE_NOTEXACT

repCASE_NOTEXACT
	move.l	a3,-(a7)			;a3 on stack
	move.l	96(a4),a3			;(greater/smaller) memoryblock REPLACE in a3 used to copy in
	move.l	72(a4),d3			;ReadFileLength
	move.l	68(a4),a2			;ReadFileBuffer in a2

	moveq	#0,d1				;d1
	move.w	84(a4),d1			;lenght SEARCH

	bra	firstrepCASE_NOTEXACT		;correct file lenght d3 (one to little)

nextrepCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFCASE_NOTEXACT		;end of file ->EOFCASE_NOTEXACT
firstrepCASE_NOTEXACT
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextrepCASE_NOTEXACT		;first char. isn't same ->nextrepCASE_NOTEXACT

startrepCASE_NOTEXACT
	move.l	d4,a1				;SEARCH base

reploopCASE_NOTEXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchrepCASE_NOTEXACT		;found ->matchrepCASE_NOTEXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFCASE_NOTEXACT		;end of file ->EOF
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextrepCASE_NOTEXACT
	bra	reploopCASE_NOTEXACT		;was same

matchrepCASE_NOTEXACT
	sub.l	d1,a3				;copyblock back
	move.l	36(a4),a0			;REPLACE in a0
replaceCASE_NOTEXACT
	move.b	(a0)+,(a3)+
	bne	replaceCASE_NOTEXACT
	sub.l	#1,a3
	bra	nextrepCASE_NOTEXACT

EOFCASE_NOTEXACT

	move.l	(a7)+,a3			;a3 restored
	bra	finiREPLACE

*****************
REPLACECASE_EXACT

;	bra	UsageText			;TEST of modify code goed werkt

;	move.l	72(a4),d3			;ReadFileLength
;	move.l	68(a4),a2			;ReadFileBuffer in a2
	move.l	d2,a2				;ReadFileBuffer already in d2 !

	clr.l	d7

	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextcountCASE_EXACT		;first char. isn't same ->nextcountCASE_EXACT

firststartcountCASE_EXACT
	move.l	d4,a1				;SEARCH base

firstcountloopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchcountCASE_EXACT	;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountCASE_EXACT		;end of file ->CanNotOpenFile (freed memory, unlock)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextcountCASE_EXACT
	bra	firstcountloopCASE_EXACT	;was same

firstmatchcountCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastcountCASE_EXACT
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextcountCASE_EXACT
;iscountCASE_EXACT
	add.l	#1,d7
	bra	nextcountCASE_EXACT

nocountCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextcountCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountCASE_EXACT		;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextcountCASE_EXACT		;first char. isn't same ->nextcountCASE_EXACT

startcountCASE_EXACT
	move.l	d4,a1				;SEARCH base

countloopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchcountCASE_EXACT		;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFcountCASE_EXACT		;end of file ->CanNotOpenFile (freed memory, unlock)
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextcountCASE_EXACT
	bra	countloopCASE_EXACT		;was same

matchcountCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nocountCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastcountCASE_EXACT
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextcountCASE_EXACT
;iscountCASE_EXACT
	add.l	#1,d7
	bra	nextcountCASE_EXACT

waslastcountCASE_EXACT
	add.l	#1,d7

EOFcountCASE_EXACT
	tst.l	d7
	beq	CanNotOpenFile

	move.l	88(a4),d0			;for replace EXACT routines, use always new memoryblock
	bmi	wassmallerCASE_EXACT

	mulu.l	d7,d0				;greater memoryblock needed (or same if 0)

	add.l	72(a4),d0			;ReadFileLength+extra REPLACE
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
;greater memoryblock REPLACE
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneCASE_EXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

wassmallerCASE_EXACT				;new smaller memoryblock, can't use old one for replace EXACT
	neg.l	d0				;make positive
	mulu.l	d7,d0
	move.l	72(a4),d1			;ReadFileLength in d1
	sub.l	d0,d1				;ReadFileLength smaller, because REPLACE is smaller
	move.l	d1,d0

;new smaller memoryblock REPLACE (needed for EXACT routine)
	add.l	#1,d0				;and extra end for possible copied null-byte (not write)
	move.l	d0,92(a4)			;lenght REPLACE memoryblock
	move.l	#MEMF_PUBLIC,d1			;memory type public
	move.l	(_SYSBase).w,a6
	jsr	_LVOAllocMem(a6)		;AllocMem(byteSize,requirements)(d0/d1) >don't trash d2,d3 !!
	move.l	d0,96(a4)			;buffer REPLACE memoryblock
	bne	blockdoneCASE_EXACT
	bsr	ioerror
	bra	CanNotOpenFile			;not succesful ->CanNotOpenFile (freed memory, unlock)

blockdoneCASE_EXACT
repCASE_EXACT
	move.l	a3,-(a7)			;a3 on stack
;	move.l	96(a4),a3			;(greater/smaller) memoryblock REPLACE in a3 used to copy in
	move.l	d0,a3				;96(a4) already in d0
	move.l	72(a4),d3			;ReadFileLength
	move.l	68(a4),a2			;ReadFileBuffer in a2


	moveq	#1,d1				;d1
	add.w	84(a4),d1			;lenght SEARCH+1

;look for first match at top of file, correct file lenght counter d3 with skipping one -1
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextrepCASE_EXACT		;first char. isn't same ->nextrepCASE_EXACT

firststartrepCASE_EXACT
	move.l	d4,a1				;SEARCH base

firstreploopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	firstmatchrepCASE_EXACT	;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextrepCASE_EXACT
	bra	firstreploopCASE_EXACT		;was same

firstmatchrepCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastrepCASE_EXACT
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextrepCASE_EXACT
;isrepCASE_EXACT
	bra	copyrepCASE_EXACT

norepCASE_EXACT
	add.l	d1,a2				;set a2 back to original value
nextrepCASE_EXACT
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2)+,d2			;file in d2
	move.b	d2,(a3)+			;NIEUW !!!
	cmp.b	d5,d2				;compare SEARCH, file
	bne	nextrepCASE_EXACT		;first char. isn't same ->nextrepCASE_EXACT

startrepCASE_EXACT
	move.l	d4,a1				;SEARCH base

reploopCASE_EXACT
	move.b	(a1)+,d0			;SEARCH base in d0
	beq	matchrepCASE_EXACT			;found ->matchfile
	subq.l	#1,d3				;file lenght one smaller
	beq	EOFCASE_EXACT			;end of file ->CanNotOpenFile (freed memory, unlock)
	move.b	(a2),(a3)+			;NIEUW !!!
	cmp.b	(a2)+,d0			;compare file, SEARCH
	bne	nextrepCASE_EXACT
	bra	reploopCASE_EXACT		;was same

matchrepCASE_EXACT

	sub.l	d1,a2				;look which char. is before matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	norepCASE_EXACT
	cmp.l	#1,d3				;is last one ?
	beq	waslastrepCASE_EXACT
	add.l	d1,a2				;set a2 back to char. behind matched
	moveq	#0,d2				;d2 clear (no possible negative)
	move.b	(a2),d2				;and in d2
	sub.w	#33,d2				;filter out special char. (TAB, Return, non printable char.)
	bpl	nextrepCASE_EXACT
;isrepCASE_EXACT

copyrepCASE_EXACT
	sub.l	d1,a3				;copyblock back
	add.l	#1,a3				;correct mischien, nog kijken !
	move.l	36(a4),a0			;REPLACE in a0
replaceCASE_EXACT
	move.b	(a0)+,(a3)+
	bne	replaceCASE_EXACT
	sub.l	#1,a3
	bra	nextrepCASE_EXACT

waslastrepCASE_EXACT
	sub.l	d1,a3				;copyblock back
	add.l	#1,a3				;correct mischien, nog kijken !
	move.l	36(a4),a0			;REPLACE in a0
lastreplaceCASE_EXACT
	move.b	(a0)+,(a3)+
	bne	lastreplaceCASE_EXACT

EOFCASE_EXACT

	move.l	(a7)+,a3			;a3 restored
;	bra	finiREPLACE

***************
* finiREPLACE *
*************** Unlock, determine to copy to savedir (which leaves original file untouched) or overwrite
;always unlock read file we want to overwrite or copy in SAVEDIR
finiREPLACE
	move.l	76(a4),d1			;savelock
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOUnLock(a6)			;UnLock(lock)(d1)

	tst.l	28(a4)				;SAVEDIR
	beq	overwriteopen			;if not (0) ->overwriteopen (overwrite file to replace)

;do replacing to savedir, original file remains untouched (no overwrite)
	move.l	a3,a0				;a3 contains the filenameaddress
	move.l	64(a4),a1			;new SAVEDIR end

appendsaverep
	move.b	(a0)+,(a1)+			;
	bne	appendsaverep			;0 -> search for null-byte

;file open
	move.l	60(a4),d1			;new SAVEDIR
	move.l	#MODE_NEWFILE,d2		;
	jsr	_LVOOpen(a6)			;Open(name,accessMode)(d1/d2)
	move.l	d0,80(a4)			;filehandle
	bne	Savefilerep
	bsr	ioerror
	bra	FreedREPLACEMemory		;not succesful ->FreedREPLACEMemory

Savefilerep
	move.l	d0,d1				;filehandle in d1
	move.l	96(a4),d2			;buffer REPLACE memoryblock
	move.l	92(a4),d3			;lenght REPLACE memoryblock

	tst.w	40(a4)				;EXACT	TRUE (-1) FALSE (0)
	bmi	writeEXACTREP			;by replace EXACT routines, always correct lenght
	tst.l	88(a4)
	bmi	writesmaller			;was smaller ->writesmaller
writeEXACTREP
	sub.l	#1,d3				;correct lenght
writesmaller

	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
	cmp.l	#-1,d0				;error occured ? -1=error
	bne	savedonerep
	bsr	ioerror
	move.l	80(a4),d1			;filehandle in d1
	jsr	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!
	bra	FreedREPLACEMemory

savedonerep
						;if from Workbench, then QUIET=-1 thus skip "copied; "
	tst.w	44(a4)				;QUIET
	bne	Savecloserep			;if yes (-1) ->Savecloserep (skip " saved..")

;"copied; "
	move.l	4(a4),d1			;outputhandle
	move.l	#copied,d2
	move.l	#8,d3
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

Savecloserep
	move.l	80(a4),d1			;filehandle in d1
	jsr 	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!

	bra	matchfileREPLACE		;print information and finishing


;here overwrite routine for replacing
overwriteopen
	move.l	48(a4),d1			;name of file to overwrite
	move.l	#MODE_NEWFILE,d2		;
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOOpen(a6)			;Open(name,accessMode)(d1/d2)
	move.l	d0,80(a4)			;filehandle
	bne	overwritefile
	bsr	ioerror
	bra	FreedREPLACEMemory		;not succesful ->FreedREPLACEMemory

overwritefile
	move.l	d0,d1				;filehandle in d1
	move.l	96(a4),d2			;buffer REPLACE memoryblock
	move.l	92(a4),d3			;lenght REPLACE memoryblock

	tst.w	40(a4)				;EXACT	TRUE (-1) FALSE (0)
	bmi	overwriteEXACTREP		;by replace EXACT routines, always correct lenght
	tst.l	88(a4)
	bmi	overwritesmaller		;was smaller ->overwritesmaller
overwriteEXACTREP
	sub.l	#1,d3				;correct lenght
overwritesmaller

	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
	cmp.l	#-1,d0				;error occured ? -1=error
	bne	overwriteclose
	bsr	ioerror
	move.l	80(a4),d1			;filehandle in d1
	jsr	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!
	bra	FreedREPLACEMemory

overwriteclose
	move.l	80(a4),d1			;filehandle in d1
	jsr 	_LVOClose(a6)			;Close(file)(d1) >don't trash d2,d3 !!


;	bra	matchfileREPLACE

***print information for REPLACE***
matchfileREPLACE

	tst.l	-4(a4)				;WBStartup Message
	beq	REPmatchfileCLI			;for Shell
;put here routine for Workbench



REPmatchfileCLI

	tst.w	44(a4)				;QUIET
	bne	endprintpathbufREP		;if yes (-1) ->endprintpathbufREP

REPprintpathbuf

	move.l	48(a4),a1			;pathbuf
	move.l	a1,d2				;address in d2 for later _LVOWrite
	moveq	#0,d3
REPpathname
	addq.w	#1,d3				;d3 path lenght counter
	tst.b	(a1)+
	bne	REPpathname

	move.b	#" ",-1(a1)			;add "space"

	move.l	4(a4),d1			;outputhandle
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

	move.l	d7,d0				;see how much the SEARCH was found into the file and replaced
	bsr	output32			;print number replaces

;"replaces.."
	move.l	4(a4),d1			;outputhandle
	move.l	#replaces,d2
	move.l	#11,d3
;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)

endprintpathbufREP

	move.l	52(a4),d1			;DELAY
;	beq	SkipDelay			;if DELAY null ->SkipDelay
	jsr	_LVODelay(a6)			;Delay(timeout)(d1)
;SkipDelay

FreedREPLACEMemory
	move.l	(_SYSBase).w,a6			;_SYSBase in a6 here

	tst.w	40(a4)				;EXACT	TRUE (-1) FALSE (0)
	bmi	freetwice			;by replace EXACT routines, always freed two memory blocks
	tst.l	88(a4)
	bmi	CanNotOpenFileREPLACE		;was smaller ->CanNotOpenFileREPLACE (there was no REPLACE block)
freetwice
	move.l	96(a4),a1			;buffer REPLACE memoryblock
	move.l	92(a4),d0			;lenght REPLACE memoryblock
;	move.l	(_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0) >don't trash d2,d3 !!

CanNotOpenFileREPLACE				;freed read file memory

	move.l	68(a4),a1			;ReadFileBuffer
	move.l	72(a4),d0			;ReadFileLength
;	move.l	(_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0) >don't trash d2,d3 !!
	move.l	(a4),a6				;_DOSBase again in a6 for loop routine

	bra	loop				;


*******************************************************************
*** END REPLACE							***
*******************************************************************



************************************************
* Here comes in buffer "faultbuf" the error text, which can be print on window or requester.

ioerror:
	move.l	d4,-(a7)			;because of LVOFault trashes d4, we put d4 at stack

	move.l	(a4),a6				;_DOSBase
	jsr	_LVOIoErr(a6)			;IoErr()()

;When the directory scan is finished, d0 must hold 232 after IoErr. (means: no_more_entries)

	move.l	d0,d1				;error code obtained from IoErr in d1
	moveq	#0,d2				;no header
	move.l	#faultbuf,d3
	move.l	#81,d4				;maximal standard lenght error text

;	move.l	(a4),a6				;_DOSBase
	jsr	_LVOFault(a6)			;Fault(code,header,buffer,len)(d1/d2/d3/d4)

	move.l	(a7)+,d4

	tst.l	-4(a4)				;WBStartup Message
	beq	CLIerror			;for Shell
;put here routine for Workbench



CLIerror

;--------------Begin Print error text-----------------

	move.l	4(a4),d1			;outputhandle
	move.l	#faultbuf,d2
	move.l	d0,d3				;lenght obtained from Fault in d3
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
;"Return"
	move.l	4(a4),d1			;outputhandle
	move.l	#return,d2
	move.l	#1,d3
;	move.l	_DOSBase(pc),a6
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)


;--------------End Print error text-------------------

	rts





















WrongArguments

	move.l	4(a4),d1			;outputhandle
	move.l	#String1,d2			;print "wrong arguments"
	move.l	#16,d3				;lenght text
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
	bra	exit_closedos

UsageText

	move.l	4(a4),d1			;outputhandle
	move.l	#String2a,d2			;
	move.l	#549,d3				;lenght text
	move.l	(a4),a6				;_DOSBase
	jsr	_LVOWrite(a6)			;Write(file,buffer,length)(d1/d2/d3)
	bra	exit_closedos


*------------closing-------------------------------

freeCommandBuf

;freeFIBs routine needs pointer at end pathbuf in a5
;this is the case when the scanning subdir routine is done, otherwise use 3 under opcodes !
;It's needed too if aborted or error. not in this version, maybe future versions. (is better)

;	move.l	56(a4),a5
;	add.l	32(a4),a5			;add BUFFER value and a5 points at end
;	sub.l	#4,a5				;correct a5

freeFIBs 					;free FileInfoBlock's

	sub.l	#12,a5				;
	move.l	(a5),a1				;first FileInfoBlock in a1
	tst.l	a1				;needed
	beq	freepathbuf			;no more FileInfoBlock's ->freepathbuf
	move.l	#1040,d0			;lenght FileInfoBlock
	move.l	(_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0)
	bra	freeFIBs			;next FileInfoBlock

freepathbuf

	move.l	32(a4),d0			;BUFFER lenght
	move.l	56(a4),a1			;pathbuf
;	move.l	(_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0)


exit_closedos

	move.l	-4(a4),a1			;reply wb message
	tst.l	a1
	beq	endCLI				;endCLI - Task was started from CLI
;	move.l	(_SYSBase).w,a6
	jsr	_LVOReplyMsg(a6)		;ReplyMsg(message)(a1) Task was started from WB
	bra	fini
endCLI						;freed memory Commandline
	move.l	12(a4),d0			;ReadCommandLen
	move.l	16(a4),a1			;ReadCommandBuf
	move.l  (_SYSBase).w,a6
	jsr	_LVOFreeMem(a6)			;FreeMem(memoryBlock,byteSize)(a1,d0)

fini

	move.l  (a4),a1				;_DOSBase
;	move.l	(_SYSBase).w,a6
        jsr	_LVOCloseLibrary(a6)		;cleared d0 a0 a1 too !
fini2
;	moveq	#0,d0				;Return code
	rts					;End program



	INCLUDE	Tom/DecOutput32.i

*LONG----------------------------------

_DOSBase dc.l 0					;TEST only for output32


outputhandle dc.l 0				;TEST only for output32


*Byte----------------------------------

faultbuf blk.b 81 ;buffer used to put error text in from Fault function


*Library data------------------------------------------

dosname		DOSNAME				;name of dos library

*text data-------------------------------------------
String1 dc.b "wrong arguments",10 ;10 is "Return"
String2a dc.b "SearchStar Shell commandline arguments",10 ;len=39
String2b dc.b "Template",10 ;len=9
String2c dc.b "DIR<dirname>,SEARCH<searchname>,CASE/S,EXACT/S,SAVEDIR<dirname>,THRU/S,REPLACE<replacename>,QUIET/S,BUFFER=/N,DELAY=/N",10
String2d dc.b "argument DIR and SEARCH are required, examples;",10 ;len=48
String2e dc.b 'DIR Work: SEARCH Amigaharry SAVEDIR "Ram Disk:"',10 ;len=47
String2f dc.b " Search in drawer 'Work' to all files which matches name 'Amigaharry', and saves in 'Ram Disk'",10 ;len=89
String2g dc.b 'DIR DH0:text SEARCH "Tom Duin" THRU REPLACE "Tommy Duin" CASE EXACT QUIET',10 ;len=74
String2h dc.b " In drawer 'DH0:text', replaces all found 'Tom Duin' into files with 'Tommy Duin', case sensitive, exact, no output.",10


return dc.b 10	;
saved dc.b " saved..",10
copied dc.b "Copied; " ;for coping to SAVEDIR
replaces dc.b "replaces..",10

*Version data------------------------------------------

Version dc.b "$VER:SearchStar 0.80 beta by Amigaharry, Jan04",0