<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */

/**
* Server class
* 
* Represents an edonkey server
*
* @version  $Id: Server.php,v 1.2 2003/06/19 19:02:58 dtseiler Exp $
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @package  zuul
*/
class ZUUL_Server {
    
    /**
    * Network (eDonkey, Direct Connect, Open Napster, BitTorrent, etc.)
    *
    * @var      string
    * @access   public
    */
    var $network = NULL;


    /**
    * mldonkey Number
    *
    * @var      string
    * @access   public
    */
    var $nr = NULL;


    /**
    * IP Address of the server
    *
    * @var      string
    * @access   public
    */
    var $ip = NULL;


    /**
    * Server status
    *
    * @var      string
    * @access   public
    */
    var $status = NULL;


    /**
    * Number of files on the server
    *
    * @var      string
    * @access   public
    */
    var $files = NULL;


    /**
    * Number of users on the server
    *
    * @var      string
    * @access   public
    */
    var $users = NULL;


    /**
    * Name of the server
    *
    * @var      string
    * @access   public
    */
    var $name = NULL;

    function ZUUL_Server($line = NULL)
    {
        if(isset($line)) {
            // $line is an mldonkey response line
            // parse code lifted from phpeselgui
            // http://phpeselgui.sf.net
            if(ereg("^\[", $line)) {
                $line = preg_replace("/\[/", "", $line);
                $line = preg_replace("/\Direct Connect /", "DC ", $line);
                $line = preg_replace("/\Open Napster /", "OpenNap ", $line);
                $line = preg_replace("/\]/", "", $line);
                $line = preg_replace("/\s+/", " ", $line);
                $line = preg_replace("/\s+$/", "", $line);
                $temp=explode(" ", $line);
                $length=sizeof($temp);
                $this->network=$temp[0];
                $this->nr=$temp[1];
                $this->ip=$temp[2];
                
                if (preg_match("|[0-9]+|", $temp[$length-1])){
                    $this->status = "";
                    $this->files=$temp[$length-1];
                    $this->users=$temp[$length-2];
                    $text="";
                    
                    for ($x = 3; $x < $length-2; $x++){
                        $text .= $temp[$x]." ";
                    }
                    
                    $this->names=$text;
                } else {
                    $this->users=$temp[$length-3];
                    $this->files=$temp[$length-2];
                    $this->status=$temp[$length-1];
                    $text="";
                    
                    for ($x = 3; $x < $length-3; $x++){
                        $text .= $temp[$x]." ";
                    }
                    
                    $this->name=$text;
                }
            } else {
                $this = NULL;
            }
        }
    }// END FUNC ZUUL_Server

}// END CLASS ZUUL_Server
