<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */

/**
* Translator class
* 
* Object to handle language translations
*
* @version  $Id: Translator.php,v 1.2 2003/07/10 12:42:22 cyb0rg Exp $
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @package  zuul
*/
class ZUUL_Translator {

    var $dictionary = array();
    
    function ZUUL_Translator($language = NULL)
    {
        if(isset($language)) {
            if(file_exists(ZUUL_HOME_DIR . "/lang/$language.txt")) {
                $translations = file(ZUUL_HOME_DIR . "/lang/$language.txt");

                foreach ($translations as $translation) {
                    if(!preg_match("/^[#\/]/", $translation)) {
                        $phrase = explode(":|:", $translation);
                        $this->dictionary[trim($phrase[0])] = trim($phrase[1]);
                    }
                }
            } else {
                exit("ERROR!  Language file " . ZUUL_HOME_DIR . "/lang/$language.txt not found!");
            }
        }
    }// END FUNC ZUUL_Translator


    function translate($phrase) {
        if(isset($this->dictionary[$phrase]))
            return $this->dictionary[$phrase];
        else
            return "?" . $phrase . "?";
    }// END FUNC translate

}// END CLASS ZUUL_Translator
