#!/bin/bash

# Running this command will check through Zuul's code to look for all
# instances of translate("whatever") and create a list of every translation
# that happens in Zuul.  It will then compare this list against whatever
# language you pass in as the first argument, and give you a diff of
# the phrases that are and are not present.

# Run this from Zuul root...
if [ ! -f misc/helpers/translint-helper.pl ]; then
  echo "Run this program from your Zuul root dir"
  exit
fi

# Read the language
LANG=$1
if [ "$LANG" == "" ]; then
  echo "Specify a language on the command line"
  exit
fi

# Make sure it exists
if [ ! -f lang/$LANG.txt ]; then
  echo "Language $LANG does not exist"
  exit
fi

# Do the processing
find . -name "*.php" -exec cat {} \; | misc/helpers/translint-helper.pl > /tmp/zuul-$$-words.txt
cut -d: -f1 < lang/$LANG.txt > /tmp/zuul-$$-$LANG.txt
diff -u /tmp/zuul-$$-$LANG.txt /tmp/zuul-$$-words.txt
rm /tmp/zuul-$$-$LANG.txt /tmp/zuul-$$-words.txt
